import os
def cleanExt(ext):
    while ext.startswith("."):
        ext = ext[1:]
    return ext
def main():
    values = [("oext", lux.DIALOG_TEXT, "Output image format:", "png"),
              ("width", lux.DIALOG_INTEGER, "Render width:", 500, (1, 10000)),
              ("height", lux.DIALOG_INTEGER, "Render height:", 500, (1, 10000)),
              ("max_samples", lux.DIALOG_INTEGER, "Max Render Samples:", 32, (0, 10000)),
              ("max_time", lux.DIALOG_INTEGER, "Max Render Time (Seconds):", 0, (0, 100000)),
              ("cam", lux.DIALOG_TEXT, "Use camera. Leave blank for current:", lux.getCamera())]
    opts = lux.getInputDialog(title = "Render 3ds max frames",
                              desc = "",
                              values = values)
    if not opts: return
    if len(opts["oext"]) == 0:
        raise Exception("Output extension cannot be empty!")
    oext = cleanExt(opts["oext"])
    if opts["max_samples"] == 0 and opts["max_time"] == 0:
      raise Exception("Use either max samples or max time!")
    if opts["max_samples"] != 0 and opts["max_time"] != 0:
      raise Exception("Use either max samples or max time!")
    start = 1
    end = 10
    cam = opts["cam"]
    io = lux.getImportOptions()
    io['adjust_camera_look_at'] = False
    io['adjust_environment'] = False
    io['update_mode'] = True
    io['merge'] = True
    io['camera_import'] = True
    io['new_import'] = False
    ro = lux.getRenderOptions()
    ro.setAddToQueue(True)
    if opts["max_samples"] > 0:
      ro.setMaxSamplesRendering(opts["max_samples"])
    if opts["max_time"] > 0:
      ro.setMaxTimeRendering(opts["max_time"])
    for i in range (start, end+1):
        path = "C:/Users/claudio.ZEEVA/Documents/test animation/testanim" + str(i).zfill(4) + ".bip"
        print("Importing {}".format(path))
        if not lux.importFile(path, False, True, io):
          raise Exception("Error in import! User cancelled?")
        if len(cam) != 0:
          lux.setCamera(cam)
        lux.setAnimationFrame(i)
        path = "C:/Users/claudio.ZEEVA/Documents/test animation/testanim" + str(i).zfill(5) + "." + oext
        print("Rendering {}".format(path))
        if not lux.renderImage(path, opts["width"], opts["height"], ro):
          raise Exception("Error in Render! User cancelled?")
main()
